# LIBUSB USAGE

Example and test application source code is in **example** folder.

### send_frame

- usage: send_frame [frame data file] 

- used to send one frame(bmp 16bit format data without bitmap header) to screen.
- example: **send_frame frame.dat**

### read_touch

- usage: read_touch
- used to read touch screen position and press status, no parameter.

### send_cmd

-  usage: send_cmd [cmd] [param]
-  used to send command to screen, control screen rotated or backlight.
- example: mirror by axis x,y [0,1,2,3] to mode1  **send_cmd m 1**
- example: set backlight [0~255] to 120 **send_cmd b 120**

# FRAMEBUFFER USAGE

fbusb source code is in **fbusb** folder. Put it to openwrt/package, then select in openwrt menuconfig => VoCore2 => kmod-fbusb

## Install

We use fbusb.ko as the framebuffer/touch driver for Linux.

- fbusb.ko: for Linux system, framebuffer is supported. 
- example: **insmod fbusb.ko**

## Attributes

fbusb has three attribute: **command, frame_count, pause**

- command: used to send command to screen.
- frame_count: used to get the total frame number send from system to screen. 
- pause: start or stop write to USB screen.

## Get Frame Count 

```bash
cat `find /sys/devices/platform/101c0000.ehci -name frame_count`
```

## Pause/Restore Frame Upload

```bash
# pause frame write
echo 1 > `find /sys/devices/platform/101c0000.ehci -name pause`

# restore frame write
echo 0 > `find /sys/devices/platform/101c0000.ehci -name pause`
```

## Mirror Screen

```bash
# mode 1
echo -e '\x00\x36\x02\x00\x00\x00\x00\x00' > `find /sys/devices/platform/101c0000.ehci -name command`

# mode 2
echo -e '\x00\x36\x02\x00\x00\x00\x01\x00' > `find /sys/devices/platform/101c0000.ehci -name command`

# mode 3
echo -e '\x00\x36\x02\x00\x00\x00\x02\x00' > `find /sys/devices/platform/101c0000.ehci -name command`

# mode 4
echo -e '\x00\x36\x02\x00\x00\x00\x03\x00' > `find /sys/devices/platform/101c0000.ehci -name command`
```

## Backlight Brightness

Send command by echo to /sys folder command attribute. 

```bash
# turn off backlight
echo -e '\x00\x51\x02\x00\x00\x00\x00\x00' > `find /sys/devices/platform/101c0000.ehci -name command`

# set backlight brightness to max
echo -e '\x00\x51\x02\x00\x00\x00\xff\x00' > `find /sys/devices/platform/101c0000.ehci -name command`

# set backlight brightness to 128(half)
echo -e '\x00\x51\x02\x00\x00\x00\x80\x00' > `find /sys/devices/platform/101c0000.ehci -name command`
```